<?php

/**
 * Einstellungen die unter keine andere Kategorie passen.
 * @author Miguel Palmer <mp@beronet.com>
 */
class Miscellaneous {

	/**
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 * @return string HTML code
	 */
	function display() {

		$name = "MISCELLANEOUS_TITLE_DIS";
		include('./includes/header.php');

		$ret .= $this->dynamic_table();
		//Return: Site content
		return $ret;
	}

	/**
	 * SIP license reload
	 * @return void
	 */
	function reload_sip_license() {
		require_once ('./includes/isgwtelnet.php');
		$isgw = new isgwtelnet();
		$isgw->isgw_login();
		$isgw->isgw_siplicenserefresh();
	}

	/**
	 * Generates the checkbox reject calls under load
	 * @return string
	 */
	function reject_calls_under_load() {
		$ba = new beroAri();
		$option = $ba->get("reject_calls_under_load");
		if ($option == "1") {
			$checked = "checked";
		}
		ob_start();
		?>
		<input type='hidden' name='reject_calls_under_load' value='0'>
		<input type='checkbox' name='reject_calls_under_load' value='1' <? echo $checked ?>>
		<?php
		return ob_get_clean();
	}

	/**
	 * @return string HTML Formular
	 */
	function dynamic_table() {
		$table = "";
		require_once("./includes/lang.php");
		require_once('/usr/fallback/beroConf.php');
		$bc = new beroConf('root');
		$ba = new beroAri();

		if (isset($_GET['reload'])) {
			$this->reload_sip_license();
		}
		//Upload SIP License
		if ($_FILES["uploadfile"]["name"] != "") {
			$file_name = $_FILES["uploadfile"]["name"];
			$tmp_file = $_FILES["uploadfile"]["tmp_name"];
			if ($file_name != "isgw_" . SERIAL . ".license") { //40 kB
				$table .= "<div class='text-center'><font color='red'>" . MISCELLANEOUS_INVALID_FILENAME_DIS . "</font></div>";
			} elseif ($_FILES["uploadfile"]["size"] > 40000) { //40 kB
				$table .= "<div class='text-center'><font color='red'>" . SIP_STACKS_FILE_SIZE_DIS . "</font></div>";
			} else {
				@unlink("/usr/conf/" . $file_name);
				exec("/bin/cp " . $tmp_file . " /usr/conf/" . $file_name);
				$this->reload_sip_license();
				$table .= "<div class='text-center'><font color='red'>" . SIP_STACKS_UPLOAD_SUCCESS_DIS . "</font></div>";
			}
		}

		//Save changes
		if ($_POST['action'] == 'save') {
			$option = 1;
			if (isset($_POST['experimental_options'])) {
				if ($_POST['experimental_options'] != $ba->get("experimental_options"))
					$option = 3;
				$ba->set("experimental_options", sqlite_escape_string($_POST["experimental_options"]));
				$ba->set("international_code", sqlite_escape_string($_POST["international_code"]));
				$ba->set("national_code", sqlite_escape_string($_POST["national_code"]));
				$ba->set("reject_calls_under_load", sqlite_escape_string($_POST['reject_calls_under_load']));
				$ba->set("emergency_numbers", sqlite_escape_string($_POST['emergency_numbers']));
			}

			$table .= Helper::activate($option, true, $_GET['m'], ACTIVATE);
		}
		ob_start();
		?>
		<br>
		<form name='miscellaneous' id='misc-form' class = "form-horizontal" action='' method='POST'>
			<input type=hidden name=m value='<? echo $_GET['m'] ?>'>
			<input type=hidden name=a value='save'>
			<p class="text-center lead" ><? echo MISCELLANEOUS_TABLE_HEADER_DIS ?></p>
			<div class='form-group'>
				<label for='experimental_options' class='col-sm-5 control-label'><? echo MISCELLANEOUS_EXPERIMENTAL_OPTIONS_DIS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='experimental_options' name='experimental_options' 
						   value='<? echo $ba->get("experimental_options") ?>'>
				</div>
			</div>
			<div class='form-group'>
				<label for='reject_calls_under_load' class='col-sm-5 control-label'><? echo MISCELLANEOUS_REJECT_CALLS_UNDER_LOAD_DIS ?></label>
				<div class='col-sm-4'>
					<? echo $this->reject_calls_under_load() ?>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_COUNTRY_CODE; ?>'>
				<label for='international_code' class='col-sm-5 control-label'><? echo DIALPLAN_SIP_INTERNATIONAL_CODE_DIS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='international_code' name='international_code' value='<? echo $ba->get("international_code") ?>'>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_CITY_CODE; ?>'>
				<label for='national_code' class='col-sm-5 control-label'><? echo DIALPLAN_SIP_NATIONAL_CODE_DIS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='national_code' name='national_code' value='<? echo $ba->get("national_code") ?>'>
				</div>
			</div>
			<div class='form-group' data-toggle='tooltip' title='<? echo MISCELLANEOUS_EMERGENCY_NUMBERS; ?>'>
				<label for='emergency_numbers' class='col-sm-5 control-label'><? echo SIP_EMERGENCY_NUMBERS ?></label>
				<div class='col-sm-4'>
					<input type='text' class='form-control' id='emergency_numbers' name='emergency_numbers' value='<? echo $ba->get("emergency_numbers") ?>'>
				</div>
			</div>
			<div class='text-center'>
				<input type='hidden' name='action' value='save'>
				<input name='submit' class='btn btn-default'  type='submit' value='<? echo BUTTON_SAVE ?>' >
			</div>
		</form>
		<script type='text/javascript'>
			function show_tr_adminPass() {
				if ($('#userapp-enabled').is(':checked'))
					$('#admin-pass').css('display', '');
				else
					$('#admin-pass').css('display', 'none');
			}
			$('#userapp-enabled').change(function () {
				show_tr_adminPass();
			});
			$(document).ready(function () {
				show_tr_adminPass();

				$("#misc-form").validate({
					rules: {
						international_code: {
							required: true,
							checkPhoneNumber: true
						},
						national_code: {
							required: true,
							digits: true
						},
					},
					highlight: function (element) {
						$(element).closest('.form-group').addClass('has-error');
					},
					unhighlight: function (element) {
						$(element).closest('.form-group').removeClass('has-error');
					}
				});
			});
		</script>
		<br>
		<br>
		<form ENCTYPE='multipart/form-data' id='license' action='' class="form-horizontal" method='POST'>
			<input type='hidden' name='m' value='<? echo $_GET['m'] ?>'>
			<p class="text-center lead" ><? echo MISCELLANEOUS_SIP_LICENSE_TABLE_HEADER_DIS ?></p>
			<div class='form-group'>
				<label for='uploadfile' class='col-sm-5 control-label'><? echo MISCELLANEOUS_UPLOAD_SIP_LICENSE_DIS ?></label>
				<div class='col-sm-4'>
					<input type='file' size='28' name='uploadfile'>
				</div>
			</div>

			<?php
			$table .= ob_get_clean();

			if (file_exists("/usr/conf/isgw_" . SERIAL . ".license")) {
				//SIP license
				require_once ('./includes/isgwtelnet.php');
				$isgw = new isgwtelnet();
				$isgw->isgw_login();
				$sip_license_state = $isgw->isgw_siplicensestate();
				$sip_license_count = $isgw->isgw_siplicensecount();
				switch (trim($sip_license_state)) {
					case "LICENSE_NONE":
						$state = LICENSE_NONE;
						break;
					case "LICENSE_INVALID":
						$state = LICENSE_INVALID;
						break;
					case "LICENSE_VALID":
						$state = LICENSE_VALID;
						break;

					default:
						break;
				}

				ob_start();
				?>
				<div class='form-group'>
					<label class='col-sm-5 control-label'><? echo MISCELLANEOUS_SIP_LICENSE_STATE_DIS ?></label>
					<div class='col-sm-4'>
						<p class="form-control-static h5"><? echo $state ?></p>
					</div>
				</div>
				<div class='form-group'>
					<label class='col-sm-5 control-label'><? echo MISCELLANEOUS_SIP_LICENSE_COUNT_DIS ?></label>
					<div class='col-sm-4'>
						<p class="form-control-static h5"><? echo $sip_license_count ?></p>
					</div>
				</div>
				<div class='form-group'>
					<label class='col-sm-5 control-label'><? echo MISCELLANEOUS_SIP_LICENSE_DEL_DIS ?></label>
					<div class='col-sm-4'>
						   <input type='button' class='btn btn-default' value='<? echo BUTTON_DELETE ?>' onclick="javascript:if (confirm('<? echo MISCELLANEOUS_DELETE_LICENSE_MESS_DIS ?>?') == true)
			                                    window.location.href = 'misc/deletefile.php?m=<? echo $_GET['m'] ?>&option=sip_license';">
					</div>
				</div>

				<?php
				$table .= ob_get_clean();
			}
			ob_start();
			?>

			<br>
			<div class='text-center'>
				<input name='save_lic' class='btn btn-default'  type='submit' value='<? echo BUTTON_SAVE ?>' >
			</div>
		</form>
		<?php
		$table .= ob_get_clean();
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
?>
